package com.example.altid_lib

import io.flutter.plugin.common.MethodCall
import io.flutter.plugin.common.MethodChannel
import io.flutter.plugin.common.MethodChannel.MethodCallHandler
import io.flutter.plugin.common.MethodChannel.Result
import io.flutter.plugin.common.PluginRegistry.Registrar
import altidlib.Altidlib

class AltidLibPlugin : MethodCallHandler {

    companion object {
        @JvmStatic
        fun registerWith(registrar: Registrar) {
            val channel = MethodChannel(registrar.messenger(), "altid_lib")
            channel.setMethodCallHandler(AltidLibPlugin())

        }
    }
    private fun buildList(sl: Servicelist): List<Map<String, Any>> {
        val result = List<Map<String, Any>>()
        do {
            val item = sl.next()?.apply {
                val entry = mapOf<String, Any>(
                        "name" to name(),
                        "address" to address(),
                        "port" to port()
                )
                result.add(entry)
            }
        } while (item != null)

        return result
    }

    // Something like getsession(name: name): and return a type that flutter can use
    // It will call a method on the session with a name, and we use scoped types here
    // to do the Go method calls.
    override fun onMethodCall(call: MethodCall, result: Result) {

        if (call.method == "getLocalServices") {
            try {
                sl = Altidlib.GetLocalServices()
                result.success(buildList(sl))
            } catch (e: Exception) {
                result.error("NATIVE_ERR", e.message!!, null)
            }
        } else if (call.method == "getSession") {

        } else {
            result.notImplemented()
        }
    }
}
